SystemOrganization addCategory: #'CTranslator-Hierarchy'!
SystemOrganization addCategory: #'CTranslator-Utilities'!
SystemOrganization addCategory: #'CTranslator-Translators-Cpp'!
SystemOrganization addCategory: #'CTranslator-Translators-C'!
SystemOrganization addCategory: #'CTranslator-Exceptions'!
SystemOrganization addCategory: #'CTranslator-Programs'!
SystemOrganization addCategory: #'CTranslator-Output-Cpp'!
SystemOrganization addCategory: #'CTranslator-Output-C'!

!ClassDescription methodsFor: '*CTranslator' stamp: 'Richo 1/3/2012 16:19'!
instVarNamesUpTo: aClass 
	self = aClass
		ifTrue: [^ self instVarNames]
		ifFalse: [^ self instVarNames, (superclass ifNil: [#()] ifNotNil: [:sc | sc instVarNamesUpTo: aClass])]! !

!ClassDescription methodsFor: '*CTranslator' stamp: 'Richo 10/21/2011 20:54'!
instVarTypesUpTo: aClass 
	self = aClass
		ifTrue: [^ self instanceVariableTypes]
		ifFalse: [^ self instanceVariableTypes, (superclass instVarTypesUpTo: aClass)]! !

!ClassDescription methodsFor: '*CTranslator' stamp: 'Richo 2/21/2011 15:15'!
ultimateCompiledMethodAt: selector ifAbsent: aBlock
	"Return the compiled method at selector, deferring to superclass if necessary"
	^ self compiledMethodAt: selector ifAbsent:
		[superclass
			ifNil:
				[aBlock value]
			 ifNotNil:
				[superclass ultimateCompiledMethodAt: selector ifAbsent: aBlock]]! !

Notification subclass: #CInstVarToImplement
	instanceVariableNames: 'variable struct'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Exceptions'!

!CInstVarToImplement class methodsFor: 'instance creation' stamp: 'Richo 10/7/2011 19:36'!
inStruct: aTranslatedStruct var: aTranslatedVariable
	^ self basicNew initializeWithStruct: aTranslatedStruct var: aTranslatedVariable! !

!CInstVarToImplement methodsFor: 'initialization' stamp: 'Richo 10/7/2011 19:25'!
initializeWithStruct: aStruct var: aVariable
	self initialize.
	struct := aStruct.
	variable := aVariable! !

!CInstVarToImplement methodsFor: 'accessing' stamp: 'Richo 10/7/2011 19:25'!
struct
	^ struct! !

!CInstVarToImplement methodsFor: 'accessing' stamp: 'Richo 10/7/2011 19:18'!
variable
	^ variable! !

Notification subclass: #CMethodToImplement
	instanceVariableNames: 'methodClass methodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Exceptions'!

!CMethodToImplement class methodsFor: 'instance creation' stamp: 'Richo 6/20/2011 21:04'!
class: aClass selector: aByteSymbol 
	^ (self basicNew setClass: aClass selector: aByteSymbol) initialize! !

!CMethodToImplement methodsFor: 'printing' stamp: 'Richo 6/20/2011 21:04'!
description
	"Return a textual description of the exception."
	^ 'To implement: ' , methodClass asString , '>>' , methodSelector printString! !

!CMethodToImplement methodsFor: 'accessing' stamp: 'Richo 6/20/2011 21:04'!
methodClass
	^ methodClass! !

!CMethodToImplement methodsFor: 'accessing' stamp: 'Richo 6/20/2011 21:04'!
methodSelector
	^ methodSelector ! !

!CMethodToImplement methodsFor: 'private' stamp: 'Richo 6/20/2011 21:04'!
setClass: aClass selector: aByteSymbol 
	methodClass := aClass.
	methodSelector := aByteSymbol! !

RBProgramNodeVisitor subclass: #CMethodTranslator
	instanceVariableNames: 'source class kit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Translators-C'!

!CMethodTranslator commentStamp: 'Richo 3/1/2012 18:55' prior: 0!
A CMethodTranslator is responsible of translating just a simple method, it doesn't care of much else. If it encounters something it doesn't know how to handle (i.e. an inst var, or a message send to another non-primitive method) it will signal a notification that the sender (usually a CProgramTranslator) will have to handle.

Usage:
====

	CMethodTranslator
		translate: #rounded
		of: CLong
		with: CKit!

!CMethodTranslator class methodsFor: 'instance creation' stamp: 'Richo 6/28/2011 11:29'!
new
	^ self shouldNotImplement! !

!CMethodTranslator class methodsFor: 'translating' stamp: 'Richo 9/28/2011 16:51'!
translate: selector of: class with: aKit
	^ (self withKit: aKit) translate: selector of: class! !

!CMethodTranslator class methodsFor: 'instance creation' stamp: 'Richo 9/28/2011 16:50'!
withKit: aKit
	^ self basicNew initializeWith: aKit! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 6/30/2011 12:43'!
acceptAssignmentNode: anAssignmentNode
	self visitNode: anAssignmentNode variable.
	source nextPutAll: ' = '.
	self visitNode: anAssignmentNode value.
	source nextPut: $;; cr.! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 10/13/2011 16:45'!
acceptBlockNode: aBlockNode 
	self flag: #Richo. "What to do here?"
	super acceptBlockNode: aBlockNode! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptCascadeNode: aCascadeNode
	aCascadeNode messages do: [:each | self visitNode: each. source nextPut: $;; cr].! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 3/1/2012 19:14'!
acceptLiteralNode: aLiteralNode
	| value |
	value := aLiteralNode value.
	value isFloat 
		ifTrue: [source nextPutAll: (value printShowingAtMostDecimalPlaces: 12).
			^ self].
	value isString 
		ifTrue: [source nextPut: $"; nextPutAll: value asString; nextPut: $".
			^ self].
	value isNil
		ifTrue: [source nextPutAll: 'NULL'.
			^ self].
	source nextPutAll: value asString! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 10/24/2011 14:22'!
acceptMessageNode: aMessageNode 
	| method receiverClass |
	receiverClass := self findClassOf: aMessageNode receiver.
	method := receiverClass ultimateCompiledMethodAt: aMessageNode selector ifAbsent: [self error: 'Method not found'].

	"Is it a c primitive?"
	(method pragmaAt: #c:)
		ifNotNil: [:nxcPrim | source nextPutAll: ((CPrimitiveRule on: nxcPrim arguments first) applyTo: aMessageNode using: self).
			^ self].

	"Should I inline the first argument?"
	(method pragmaAt: #c)
		ifNotNil: [:ign | source nextPutAll: aMessageNode arguments first value; cr. ^self].

	"Is it a creation method?"
	(method pragmaAt: #creationMethod)
		ifNotNil: [:pragma | self storeInstanceCreation: receiverClass.
			^ self].

	"If we got here, it is a regular method call and we need to signal the MethodToImplement exception."
	(CMethodToImplement
		class: receiverClass
		selector: aMessageNode selector)
			signal.
	self storeRegularMessageSend: aMessageNode! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 7/27/2011 17:59'!
acceptMethodNode: aMethodNode
	"I make sure the last statement is a return self"
	super acceptMethodNode: aMethodNode.
	aMethodNode lastIsReturn ifFalse: [self visitNode: self selfReturn]! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptPragmaNode: aPragmaNode
	"Do nothing"! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptReturnNode: aReturnNode
	source nextPutAll: 'return '.
	self visitNode: aReturnNode value.
	source nextPut: $;; cr.! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 7/27/2011 17:58'!
acceptSequenceNode: aSequenceNode
aSequenceNode statements do: [:each | 
	self visitNode: each.
	each isMessage ifTrue: [source nextPut: $;; cr]]! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 4/9/2012 16:44'!
acceptVariableNode: aVariableNode
	"Is it a non primitive value outside of variable assignment?"
	"((CTypeCollector findTypeOf: aVariableNode in: class) isPrimitive not 
		and: [(aVariableNode parent isAssignment) not])
			ifTrue: [source nextPut: $&]."

	"Is it an inst var?"
	((class instVarNamesUpTo: CObject) includes: aVariableNode name)
		ifTrue: [self signalInstVarToImplement: aVariableNode.
			source nextPutAll: 'self->'].	

	"Is it 'self' on the class side?"
	(class isMeta and: [aVariableNode name = 'self'])
		ifTrue: [source nextPutAll: class instanceSide asCString, '_class'.
			^ self].
	
	"Is it a class?"
	(Smalltalk includesKey: aVariableNode name asSymbol)
		ifTrue: [source nextPutAll: aVariableNode name asCIdentifier, '_class'.
			^ self].
	
	source nextPutAll: aVariableNode name asCIdentifier.! !

!CMethodTranslator methodsFor: 'accessing' stamp: 'Richo 4/9/2012 16:47'!
argVarsOf: methodNode
	^ Array streamContents: [:arguments |
		arguments nextPut: (self kit newVariableNamed: 'self' type: (self kit newTypeFor: class)).
		methodNode arguments do: [:each | 
			arguments nextPut: (self kit
					newVariableNamed: each name asCIdentifier
					type: (self findTypeOf: each))]]! !

!CMethodTranslator methodsFor: 'finding types' stamp: 'Richo 10/7/2011 19:39'!
findClassOf: node
	^ CTypeCollector findClassOf: node in: class with: self kit! !

!CMethodTranslator methodsFor: 'finding types' stamp: 'Richo 10/7/2011 19:37'!
findTypeOf: node
	^ CTypeCollector findTypeOf: node in: class with: self kit! !

!CMethodTranslator methodsFor: 'initializing' stamp: 'Richo 9/28/2011 16:51'!
initializeWith: aKit
	kit := aKit.
	self initialize! !

!CMethodTranslator methodsFor: 'accessing' stamp: 'Richo 9/28/2011 16:51'!
kit
	^ kit! !

!CMethodTranslator methodsFor: 'accessing' stamp: 'Richo 7/27/2011 13:40'!
selfReturn
	^ RBReturnNode value: (RBVariableNode named: 'self')! !

!CMethodTranslator methodsFor: 'signaling errors' stamp: 'Richo 4/9/2012 16:46'!
signalInstVarToImplement: aVariableNode 
	^ (CInstVarToImplement
		inStruct: (self kit newStructFor: class)
		var: (self kit
				newVariableNamed: aVariableNode name asCIdentifier
				type: (self findTypeOf: aVariableNode))) signal ! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 10/13/2011 13:50'!
storeInstanceCreation: aMetaclass 
"	self halt.
	String streamContents: [:stream |
		stream nextPutAll: 'basicNew'; cr;
			tab; nextPutAll: '<returnType: #(', aMetaclass instanceSide name, ')>'; cr.
		aMetaclass instanceSide instVarNames
			do: [:var |
				stream tab; nextPutAll: var, ' := nil.'; cr.
				]
	]."
	source nextPutAll: (('({1}*)malloc(sizeof({1}))') format: {aMetaclass instanceSide name})! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 10/11/2011 10:29'!
storeRegularMessageSend: aMessageNode
	source nextPutAll: 	(self findTypeOf: aMessageNode receiver) name, aMessageNode selector asCIdentifier, '('.
	{aMessageNode receiver}, aMessageNode arguments
		do: [:each | self visitNode: each]
		separatedBy: [source nextPutAll: ', '].
	source nextPut: $)! !

!CMethodTranslator methodsFor: 'accessing' stamp: 'Richo 4/9/2012 16:48'!
tempVarsOf: methodNode 
	^ Array streamContents: [:temporaries |
		methodNode allTemporaryVariables
			do: [:varName | 
				temporaries nextPut: (self kit
					newVariableNamed: varName asCIdentifier
					type: (self
							findTypeOf: ((RBVariableNode named: varName) parent: methodNode)))]]! !

!CMethodTranslator methodsFor: 'translating' stamp: 'Richo 3/1/2012 17:20'!
translate: selector of: aClass
	| methodNode |
	source := WriteStream on: ''.
	class := aClass.
	methodNode := (RBParser parseMethod: (class ultimateSourceCodeAt: selector ifAbsent: [self error: 'Source code not found'])).
	self visitNode: methodNode.
	^ self kit 
		newFunctionFor: class
		selector: methodNode selector 
		body: source contents
		arguments: (self argVarsOf: methodNode)
		temporaries: (self tempVarsOf: methodNode)
		returnType: (self findTypeOf: methodNode)
		selfType: (self kit newTypeFor: class)! !

!CMethodTranslator methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
visitArguments: aNodeCollection 
	"Do nothing"! !

!CMethodTranslator methodsFor: 'translating' stamp: 'Richo 6/20/2011 20:59'!
withClass: aClass do: aBlock
	"Replaces the class just for running the block, then it goes back to the old class.
	Very useful for translating inlined methods, which needs to use the same source but change the current class"
	| old |
	old := class.
	class := aClass.
	aBlock value.
	class := old! !

!CMethodTranslator methodsFor: 'translating' stamp: 'Richo 6/20/2011 21:12'!
withSource: aWriteStream do: aBlock
	"Replaces the source stream just for running the block, then it goes back to the old source.
	Very useful for CPrimitiveRule, which needs to translate just specific expressions without messing with already translated stuff"
	| oldSource |
	oldSource := source.
	source := aWriteStream.
	aBlock value.
	source := oldSource! !

CMethodTranslator subclass: #CppMethodTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Translators-Cpp'!

!CppMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 4/9/2012 16:45'!
acceptVariableNode: aVariableNode 
	(class bindingOf: aVariableNode name)
		ifNotNil: [:association | association value isLiteral
				ifTrue: [source nextPutAll: association value asString;
						 space;
						 nextPutAll: '/* ' , association key , ' */'.
					^ self]].
			
	"Is it an inst var?"
	((class instVarNamesUpTo: CObject) includes: aVariableNode name)
		ifTrue: [self signalInstVarToImplement: aVariableNode].
							
	aVariableNode name = 'self'
		ifTrue: [source nextPutAll: 'this']
		ifFalse: [source nextPutAll: aVariableNode name asCIdentifier]! !

!CppMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 4/9/2012 16:48'!
argVarsOf: methodNode
	"In c++ we don't need to add the self variable as the first argument"
	^ Array streamContents: [:arguments |
		methodNode arguments do: [:each | 
			arguments nextPut: (self kit
					newVariableNamed: each name asCIdentifier
					type: (self findTypeOf: each))]]! !

!CppMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 7/27/2011 16:17'!
storeInstanceCreation: aMetaclass 
	source nextPutAll: (('(new {1}())') format: {aMetaclass instanceSide name})! !

!CppMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 1/3/2012 18:04'!
storeMessageSendToPrimitiveObject: aMessageNode 
	| receiverClass |
	receiverClass := self findClassOf: aMessageNode receiver.
	source nextPutAll: receiverClass name;
			nextPutAll: '::';
			nextPutAll: aMessageNode selector asCIdentifier;
			nextPut: $(.
	{aMessageNode receiver}, aMessageNode arguments
		do: [:each | self visitNode: each]
		separatedBy: [source nextPutAll: ', '].
	source nextPut: $)! !

!CppMethodTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 1/3/2012 18:29'!
storeRegularMessageSend: aMessageNode
	| receiverClass |
	receiverClass := (self findClassOf: aMessageNode receiver).
	receiverClass isMeta
		ifTrue: ["The method is static (i.e. class side)"
			self flag: #Richo. "This *really* smells bad"
			source nextPutAll: receiverClass instanceSide asCString;
				nextPutAll: '::']
		ifFalse: [self flag: #Richo. "Fix this!!"
			receiverClass isPrimitive
				ifTrue: [self storeMessageSendToPrimitiveObject: aMessageNode.
					^ self].
			self visitNode: aMessageNode receiver.
			source nextPutAll: '->'].
	source nextPutAll: aMessageNode selector asCIdentifier, '('.
	aMessageNode arguments
		do: [:each | self visitNode: each]
		separatedBy: [source nextPutAll: ', '].
	source nextPut: $)! !

RBProgramNodeVisitor subclass: #CTypeCollector
	instanceVariableNames: 'selfClass kit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Utilities'!

!CTypeCollector commentStamp: 'Richo 3/1/2012 18:15' prior: 0!
This class is responsible of visiting a parse node and return its declared type. For now, it checks the pragma declarations for return, arguments and temporary variables, and it sends the #instanceVariableTypes message for instance variables.
Eventually, we would like to automatically infer the types used, so that we won't need to statically type every variable. When that time comes, this would be the place to start.

You can ask for a node's class or type by sending either #findClassOf:in: or #findTypeOf:in:. In the latter case, it will return an instance of CType (or a subclass, depending on the chosen kit).

Example (1):
=======

CTypeCollector
	findTypeOf: (RBParser parseExpression: '3 + 4')
	in: CObject
	with: CKit 


Example (2):
=======

CTypeCollector
	findClassOf: (RBParser parseExpression: '5 isDivisibleBy: 2')
	in: CObject
	with: CKit 


Example (3):
=======

src := 'prueba
	<returnType: #(CLong)>
	^ 3 + 4'.

CTypeCollector
	findClassOf: (RBParser parseMethod: src)
	in: CObject
	with: CKit 
!

!CTypeCollector class methodsFor: 'finding types' stamp: 'Richo 10/7/2011 19:35'!
findClassOf: aProgramNode in: aClass with: aKit
	^ (self withKit: aKit)
		findClassOf: aProgramNode in: aClass ! !

!CTypeCollector class methodsFor: 'finding types' stamp: 'Richo 10/7/2011 19:11'!
findTypeOf: aProgramNode in: aClass with: aKit
	^ (self withKit: aKit)
		findTypeOf: aProgramNode in: aClass ! !

!CTypeCollector class methodsFor: 'instance creation' stamp: 'Richo 10/7/2011 19:33'!
new
	^ self shouldNotImplement! !

!CTypeCollector class methodsFor: 'instance creation' stamp: 'Richo 10/7/2011 19:32'!
withKit: aKit
	^ self basicNew initializeWith: aKit! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptArrayNode: anArrayNode 
	self halt! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 21:21'!
acceptBlockNode: aBlockNode 
	^ CBlock! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptCascadeNode: aCascadeNode 
	^ self visitNode: aCascadeNode messages last! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptLiteralArrayNode: aRBLiteralArrayNode 
	self halt! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 21:22'!
acceptLiteralNode: aLiteralNode
	aLiteralNode value isFloat
		ifTrue: [^ CFloat].
	aLiteralNode value isNumber
		ifTrue: [^CLong].
	(#(true false) includes: aLiteralNode value)
		ifTrue: [^ CBoolean].
	aLiteralNode value isString
		ifTrue: [^ CString].
	self halt! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 10/7/2011 18:12'!
acceptMessageNode: aMessageNode 
	"It looks for the pragma #returnType: in the method being called. If not found, it returns the receiver's class."
	| receiverClass method |
	receiverClass := self findClassOf: aMessageNode receiver.
	method := receiverClass ultimateCompiledMethodAt: aMessageNode selector ifAbsent: [self error: 'Method not found'].
	
	(method pragmaAt: #returnType:)
		ifNotNilDo: [:pragma |
			^ (self computeTypes: pragma arguments first) first].

	^ receiverClass! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 7/27/2011 13:43'!
acceptMethodNode: aMethodNode
	"It looks for the #returnType: pragma to get the return type of the method"
	(aMethodNode pragmas detect: [:each | each selector = #returnType:] ifNone: [nil])
		ifNotNilDo: [:pragma | ^ (self computeTypes: pragma arguments first value) first].
	"^ CVoid"
	^ selfClass! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptPatternBlockNode: aRBPatternBlockNode 
	self halt! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptPatternWrapperBlockNode: aRBPatternWrapperBlockNode 
	self halt! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 6/20/2011 20:59'!
acceptSequenceNode: aSequenceNode 
	^ self visitNode: aSequenceNode statements last! !

!CTypeCollector methodsFor: 'visiting' stamp: 'Richo 10/24/2011 11:50'!
acceptVariableNode: aVariableNode 
	| methodNode findPragma |
	methodNode := aVariableNode methodNode.
	
	findPragma := [:selector | "Looks in the pragmas for the given selector and returns the arguments value"
		(methodNode pragmas detect: [:each | each selector = selector]
			ifNone: [self error: 'Missing ', selector printString, ' pragma for variable ', aVariableNode name printString])
			ifNotNilDo: [:pragma | pragma arguments first value]].

	"Is it an argument?"
	(methodNode arguments includes: aVariableNode)
		ifTrue: [
			^ (self computeTypes: (findPragma value: #argTypes:))
				at: (methodNode arguments indexOf: aVariableNode)].
		
	"Is it a temp var?"
	(methodNode allTemporaryVariables includes: aVariableNode name)
		ifTrue: [
			^ (self computeTypes: (findPragma value: #tempTypes:))
				at: (methodNode allTemporaryVariables indexOf: aVariableNode name)].
			
	"Is it an inst var?"
	((selfClass instVarNamesUpTo: CObject) includes: aVariableNode name)
		ifTrue: [| className |
			className := (selfClass instVarTypesUpTo: CObject)
								at: ((selfClass instVarNamesUpTo: CObject) 
										indexOf: aVariableNode name).
		"In theory, this should never throw an error"
		^ Smalltalk
			at: className
			ifAbsent: [self error: 'Invalid type: ', className]].
	
	"Is it a class?"
	(Smalltalk includesKey: aVariableNode name asSymbol)
		ifTrue: [^ (Smalltalk at: aVariableNode name asSymbol) class].
		
	self error: 'Variable''s type not found'! !

!CTypeCollector methodsFor: 'utility' stamp: 'Richo 10/7/2011 17:55'!
computeTypes: anArray 
	"It reads the array from method tags and returns an array of c types"
	^ Array streamContents: [:outputStream | | inputStream |
	inputStream := anArray readStream.
	[inputStream atEnd]
		whileFalse: [| next |
			next := inputStream next.
			next := Smalltalk at: next ifAbsent: [
				"If the class doesn't match, it must be a message to selfClass"
				(selfClass respondsTo: next) 
					ifTrue: [selfClass perform: next]
					ifFalse: [^ self error: 'Invalid type']].
			outputStream nextPut: next]].
		! !

!CTypeCollector methodsFor: 'finding types' stamp: 'Richo 10/7/2011 18:12'!
findClassOf: aProgramNode
	"Instead of returning a CType instance wrapping a class, this method will return the class found. Sometimes it's needed to find the actual method to execute after a message send"
	aProgramNode = (RBVariableNode named: 'self')
		ifTrue: [^ selfClass].
	^ self visitNode: aProgramNode! !

!CTypeCollector methodsFor: 'finding types' stamp: 'Richo 10/7/2011 18:11'!
findClassOf: aProgramNode in: aClass 
	selfClass := aClass.
	^ self findClassOf: aProgramNode! !

!CTypeCollector methodsFor: 'finding types' stamp: 'Richo 10/7/2011 19:34'!
findTypeOf: aProgramNode
	"It wraps the class found inside a CType instance"
	^ self kit newTypeFor: (self findClassOf: aProgramNode)! !

!CTypeCollector methodsFor: 'finding types' stamp: 'Richo 6/20/2011 20:59'!
findTypeOf: aProgramNode in: aClass 
	selfClass := aClass.
	^ self findTypeOf: aProgramNode! !

!CTypeCollector methodsFor: 'initialize-release' stamp: 'Richo 10/7/2011 19:33'!
initializeWith: aKit
	kit := aKit.
	self initialize ! !

!CTypeCollector methodsFor: 'accessing' stamp: 'Richo 10/7/2011 19:34'!
kit
	^ kit! !

!String methodsFor: '*CTranslator' stamp: 'Richo 4/9/2012 16:41'!
asCIdentifier
"
'Richo' asCIdentifier.
'Richo es un capo' asCIdentifier.
'foo_bar(234)' asCIdentifier.
'guin1'.
'nio' asCIdentifier.
'PROGRAMAO' asCIdentifier
"

^ self inject: '_' into: [:subTotal :next |
	(($a to: $z), ($A to: $Z), ($0 to: $9) includes: next)
		ifTrue: [
			subTotal, next asString]
		ifFalse: [subTotal , '_', next asciiValue asString]]! !

Object subclass: #CFormatter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Utilities'!

!CFormatter commentStamp: 'Richo 3/1/2012 17:55' prior: 0!
A simple class used to make the autogenerated code human-readable. It basically just removes empty lines and applies indentation, that's all.

Usage:

	CFormatter format: 'int main(void) { return 0; }'!

!CFormatter class methodsFor: 'as yet unclassified' stamp: 'Richo 3/1/2012 17:19'!
format: aStreamOrString
	^ self new format: aStreamOrString! !

!CFormatter methodsFor: 'private' stamp: 'Richo 3/1/2012 17:47'!
assureNewLinesWhenNecessary: inStream
	"Assure curly brackets are between new lines"
	^ String streamContents: [:outStream || last next isNewLine |
		last := next := nil.
		isNewLine := [:chr | chr notNil and: [chr asciiValue = 13]].
		[inStream atEnd]
			whileFalse: [
				last := next.
				next := inStream next.
				next caseOf: {
					[${] -> [
						(isNewLine value: last)
							ifFalse: [outStream cr].
						outStream nextPut: next.
						(isNewLine value: inStream peek)
							ifFalse: [outStream cr]].
					[$}] -> [
						(isNewLine value: last)
							ifFalse: [outStream cr].
						outStream nextPut: next.
						(isNewLine value: inStream peek)
							ifFalse: [outStream cr]].
				} otherwise: [outStream nextPut: next]]]! !

!CFormatter methodsFor: 'private' stamp: 'Richo 3/1/2012 17:43'!
condenseBlanks: inStream
	"Condense blanks to simplify formatting"
	^ String streamContents: [:outStream || lastBlank next |
			lastBlank := false.
			[inStream atEnd]
				whileFalse: [| isSeparator |
					(next := inStream next) asciiValue
						caseOf: {
							[32] -> [isSeparator := true].
							[13] -> [isSeparator := true].
							[9] -> [isSeparator := true].
							[10] -> [isSeparator := true].
							[12] -> [isSeparator := true].
						} otherwise: [isSeparator := false].
					(isSeparator and: [lastBlank])
						ifFalse: [outStream nextPut: next].
					lastBlank := isSeparator]]! !

!CFormatter methodsFor: 'formatting' stamp: 'Richo 3/2/2012 17:52'!
format: aStreamOrString
	| result preformatted condensed indented |
	"First condense blanks"
	condensed := self condenseBlanks: aStreamOrString readStream.
	"Add new lines before and after curly brackets (if necessary)"
	preformatted := self assureNewLinesWhenNecessary: condensed readStream.
	"Add indentation"
	indented := self indent: preformatted readStream.
	"Clean up posible extra semicolons"
	result := self removeExtraSemicolons: indented readStream.
	^ result
! !

!CFormatter methodsFor: 'private' stamp: 'Richo 3/1/2012 17:42'!
indent: inStream
	^ String streamContents: [:outStream || last next indentation applyIndentation |
		last := next := nil.
		indentation := 0.
		applyIndentation := [indentation timesRepeat: [outStream tab]].
		[inStream atEnd]
			whileFalse: [
				last := next.
				next := inStream next.
				next caseOf: {
					[Character cr] -> [
						outStream nextPut: next.
						inStream peek = $}
							ifFalse: [applyIndentation value]].
					[${] -> [outStream nextPut: next.
						indentation := indentation + 1].
					[$}] -> [indentation := indentation - 1.
						applyIndentation value.
						outStream nextPut: next].
				} otherwise: [outStream nextPut: next]]]! !

!CFormatter methodsFor: 'private' stamp: 'Richo 3/21/2012 15:00'!
removeExtraSemicolons: inStream
	"As a result of an imperfect translation, there might be some extra semicolons that we need to remove (even though most compilers ignore them).
	This horribly convoluted code takes care of checking if the semicolon can be removed or not."
	self flag: #Richo.
	^ String streamContents: [:outStream || last current next blocks |
		last := current := next := nil.
		blocks := OrderedCollection new.
		[inStream atEnd]
			whileFalse: [| shouldBeAdded |
				shouldBeAdded := true.
				last := current ifNil: [''].
				current := next ifNil: [''].
				next := inStream upTo: Character cr.
				(self withBlanksTrimmed: current) 
					caseOf: {
						[';'] -> [shouldBeAdded := false].
						['{'] -> [blocks addLast: (self withBlanksTrimmed: last)].
						['}'] -> [((blocks removeLast 
									beginsWithAnyOf: #('class' 'struct'))
								and: [(self withBlanksTrimmed: next) = ';'])
									ifTrue: [shouldBeAdded := false.
										outStream 
											nextPutAll: current;
											nextPut: $;; cr]]
					} otherwise: ["Do nothing"].
				shouldBeAdded ifTrue: [outStream nextPutAll: current; cr]].
		(self withBlanksTrimmed: next) = ';'
			ifFalse: [outStream nextPutAll: next; cr]]
! !

!CFormatter methodsFor: 'private' stamp: 'Richo 3/21/2012 15:00'!
withBlanksTrimmed: str 
	"Richo: Reimplemented here due to an incompatibility between Pharo and Etoys."
	"Return a copy of the receiver from which leading and trailing blanks have been trimmed."

	| first result |
	first := str findFirst: [:c | c isSeparator not].
	first = 0 ifTrue: [^ ''].  "no non-separator character"
	result :=  str
		copyFrom: first
		to: (str findLast: [:c | c isSeparator not]).
	result isOctetString ifTrue: [^ result asOctetString] ifFalse: [^ result]! !

Object subclass: #CKit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Translators-C'!

!CKit commentStamp: 'Richo 9/28/2011 16:53' prior: 0!
A CKit is responsible for constructing a set of objects that represent the output from the translators.!

!CKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 11:31'!
functionClass
	^ CTranslatedFunction! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 3/21/2012 18:50'!
metaFunctionClass
	"In C we can use the same function class to represent meta functions"
	^ self functionClass! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 1/13/2012 18:19'!
metaStructClass
	^ CTranslatedMetaStruct! !

!CKit class methodsFor: 'building' stamp: 'Richo 3/21/2012 18:49'!
newFunctionFor: ownerClass selector: aSymbol body: bodySource arguments: argVars temporaries: tempVars returnType: aCType selfType: anotherCType 
	"If the owner class is either a metaclass or a primitive class it returns a specific translated class"
	| new |
	new := [:someClass | someClass
				class: ownerClass
				selector: aSymbol
				body: bodySource
				arguments: argVars
				temporaries: tempVars
				returnType: aCType
				selfType: anotherCType].
	ownerClass isMeta
		ifTrue: [^ new value: self metaFunctionClass].
	ownerClass isPrimitive
		ifTrue: [^ new value: self primFunctionClass].
	^ new value: self functionClass! !

!CKit class methodsFor: 'building' stamp: 'Richo 6/28/2011 11:24'!
newProgramNamed: aByteSymbol 
	^ self programClass named: aByteSymbol! !

!CKit class methodsFor: 'building' stamp: 'Richo 1/13/2012 18:50'!
newStructFor: aClass 
	aClass isMeta
		ifTrue: [^ self metaStructClass for: aClass].
	aClass isPrimitive
		ifTrue: [^ self primStructClass for: aClass].
	^ self structClass for: aClass! !

!CKit class methodsFor: 'building' stamp: 'Richo 10/7/2011 19:07'!
newTypeFor: aClass
	^ self typeClass on: aClass! !

!CKit class methodsFor: 'building' stamp: 'Richo 6/28/2011 11:49'!
newVariableNamed: aByteString type: aClass 
	^ self variableClass name: aByteString type: aClass! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 3/21/2012 18:50'!
primFunctionClass
	"In C we can use the same function class to represent primitive functions"
	^ self functionClass! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 1/13/2012 18:18'!
primStructClass
	^ CTranslatedPrimStruct! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 11:24'!
programClass
	^ CTranslatedProgram! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 16:05'!
structClass
	^ CTranslatedStruct! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 10/7/2011 19:07'!
typeClass
	^ CType! !

!CKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 16:06'!
variableClass
	^ CTranslatedVariable! !

CKit subclass: #CppKit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Translators-Cpp'!

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 11:59'!
functionClass
	^ CppTranslatedMethod! !

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 1/13/2012 19:50'!
metaFunctionClass
	^ CppTranslatedMetaMethod! !

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 3/21/2012 18:48'!
metaStructClass
	"In C++ we don't care for metaclasses, we just translate the class side methods as static"
	^self structClass! !

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 1/13/2012 19:50'!
primFunctionClass
	^ CppTranslatedPrimMethod! !

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 1/13/2012 19:12'!
primStructClass
	^ CppTranslatedPrimClass! !

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 11:59'!
programClass
	^ CppTranslatedProgram! !

!CppKit class methodsFor: 'factory methods' stamp: 'Richo 6/28/2011 16:05'!
structClass
	^ CppTranslatedClass! !

Object subclass: #CObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

CObject subclass: #CLinkedList
	instanceVariableNames: 'value next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CLinkedList class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CLinkedList class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLinkedList)! !

!CLinkedList class methodsFor: 'c-instance creation' stamp: 'Richo 7/26/2011 16:32'!
with: aNumber
	<argTypes: #(CLong)>
	<returnType: #(instanceSide)>
	^ self new value: aNumber! !

!CLinkedList methodsFor: 'as yet unclassified' stamp: 'Richo 10/12/2011 16:29'!
add: aNumber
	<argTypes: #(CLong)>
	next isNil
		ifTrue: [next := CLinkedList with: aNumber]
		ifFalse: [next add: aNumber]
	! !

!CLinkedList methodsFor: 'as yet unclassified' stamp: 'Richo 10/12/2011 16:49'!
at: aNumber
	<argTypes: #(CLong)>
	aNumber = 1
		ifTrue: [^ self].
	^ next at: aNumber - 1! !

!CLinkedList methodsFor: 'as yet unclassified' stamp: 'Richo 10/12/2011 15:35'!
initialize
	next := nil.
	value := nil! !

!CLinkedList methodsFor: 'as yet unclassified' stamp: 'Richo 7/1/2011 14:10'!
value
	<returnType: #(CLong)>
	^ value! !

!CLinkedList methodsFor: 'as yet unclassified' stamp: 'Richo 7/26/2011 16:32'!
value: aNumber
	<returnType: #(yourself)>
	<argTypes: #(CLong)>
	value := aNumber.
	^ self! !

!CObject class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:49'!
allIncludes
	^ self includesUpTo: CObject! !

!CObject class methodsFor: 'converting' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^ self name! !

!CObject class methodsFor: 'c-instance creation' stamp: 'Richo 3/29/2012 15:19'!
basicNew
<returnType: #(instanceSide)>
<creationMethod>
^ super basicNew! !

!CObject class methodsFor: 'definition' stamp: 'Richo 2/22/2012 09:34'!
definition
	"Answer a String that defines the receiver."
	"Overwritten to show the #instanceVariablesTypes: message in the class definition of CObject subclasses"
	self = CObject ifTrue: [^super definition].
	^ String streamContents: [:stream |
		stream
			nextPutAll: superclass name;
			nextPutAll: self kindOfSubclass;
			store: self name;
			cr; tab; nextPutAll: 'instanceVariableNames: '; store: self instanceVariablesString;
			cr; tab; nextPutAll: 'instanceVariableTypes: '; store: self instanceVariableTypes;
			cr; tab; nextPutAll: 'classVariableNames: '; store: self classVariablesString;
			cr; tab; nextPutAll: 'category: '; store: (SystemOrganization categoryOfElement: self name) asString;
			cr; tab; nextPutAll: 'includes: '; store: self includes]! !

!CObject class methodsFor: 'definition' stamp: 'Richo 6/20/2011 17:53'!
definitionST80
	"Only useful for the Etoys image"
	self = CObject ifTrue: [^super definitionST80].
	^ self definition! !

!CObject class methodsFor: 'definition' stamp: 'Richo 12/28/2011 15:12'!
includes
	"This method will be automaticaly generated for subclasses whenever a subclass of CObject is compiled. It returns the information of the included libraries. I choose to do it this way (instead of using an class inst var) to ensure the type info will be saved when we file out this class or store it using Monticello"
	^ #()! !

!CObject class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:45'!
includes: anArray
"Automatically compiles a method called #includes that returns the array given as a parameter"
self class compile: 'includes
"This method was autogenerated. Do not change unless you *really* know what you''re doing"
^ ', anArray asString classified: #definition
! !

!CObject class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:49'!
includesUpTo: class
	| currentClass includes |
	currentClass := self.
	includes := Set new.
	[includes addAll: currentClass includes]
		doWhileFalse: [(currentClass := currentClass superclass) = class superclass].
	^ includes
	! !

!CObject class methodsFor: 'definition' stamp: 'Richo 6/20/2011 17:53'!
instanceVariableTypes
	"This method will be automaticaly generated for subclasses whenever a subclass of CObject is compiled. It returns the information of the inst vars' type. I choose to do it this way (instead of using an class inst var) to ensure the type info will be saved when we file out this class or store it using Monticello"
	^ #()! !

!CObject class methodsFor: 'definition' stamp: 'Richo 12/28/2011 15:15'!
instanceVariableTypes: anArray
"Automatically compiles a method called #instanceVariableTypes that returns the array given as a parameter"
self class compile: 'instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you''re doing"
^ ', anArray asString classified: #definition
! !

!CObject class methodsFor: 'testing' stamp: 'Richo 6/30/2011 12:26'!
isPrimitive
	^ false! !

!CObject class methodsFor: 'c-instance creation' stamp: 'Richo 7/25/2011 15:43'!
new
	<returnType: #(instanceSide)>
	^ self basicNew initialize! !

!CObject class methodsFor: 'definition' stamp: 'Richo 6/20/2011 17:27'!
subclass: aSymbol category: aString
	^ self subclass: aSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: aString! !

!CObject class methodsFor: 'definition' stamp: 'Richo 2/22/2012 09:32'!
subclass: nameOfClass instanceVariableNames: instVarNames instanceVariableTypes: instVarTypes classVariableNames: classVarNames category: category1 includes: includesArray
	^ self subclass: nameOfClass
		instanceVariableNames: instVarNames
		instanceVariableTypes: instVarTypes
		classVariableNames: classVarNames
		poolDictionaries: ''
		category: category1
		includes: includesArray! !

!CObject class methodsFor: 'definition' stamp: 'Richo 7/26/2011 15:24'!
subclass: nameOfClass instanceVariableNames: instVarNames instanceVariableTypes: instVarTypes classVariableNames: classVarNames poolDictionaries: poolDictnames category: category1 
	"Overwritten to allow defining the inst vars' type info of a class"
	^ (self
		subclass: nameOfClass
		instanceVariableNames: instVarNames
		classVariableNames: classVarNames
		poolDictionaries: poolDictnames
		category: category1)
		instanceVariableTypes: instVarTypes ! !

!CObject class methodsFor: 'definition' stamp: 'Richo 12/28/2011 15:11'!
subclass: nameOfClass instanceVariableNames: instVarNames instanceVariableTypes: instVarTypes classVariableNames: classVarNames poolDictionaries: poolDictnames category: category1 includes: includesArray
	^ (self
		subclass: nameOfClass
		instanceVariableNames: instVarNames
		instanceVariableTypes: instVarTypes 
		classVariableNames: classVarNames
		poolDictionaries: poolDictnames
		category: category1)
		includes: includesArray! !

!CObject methodsFor: 'c-comparing' stamp: 'Richo 6/22/2011 16:23'!
= t1
<returnType: #(CBoolean)>
<c: '({0} == {1})'>! !

!CObject methodsFor: 'c-pointers' stamp: 'Richo 6/23/2011 16:44'!
address
"	<returnType: #(*)>"
	<c: '&{0}'>! !

!CObject methodsFor: 'c-comparing' stamp: 'Richo 10/11/2011 17:56'!
isNil
<returnType: #(CBoolean)>
<c: '({0} == NULL)'>
self flag: #Richo. "It depends on the variables being initialized to 0. I should find a better way to do this..."! !

!CObject methodsFor: 'c-pointers' stamp: 'Richo 6/23/2011 16:43'!
pointer
	<c: '*{0}'>! !

!CObject methodsFor: 'c-comparing' stamp: 'Richo 6/22/2011 16:23'!
~= t1
<returnType: #(CBoolean)>
<c: '({0} !!= {1})'>! !

CObject subclass: #CPrimitiveType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

CPrimitiveType subclass: #CBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CBlock class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	"Blocks are not *really* primitive types, but they're certainly not regular objects. For instance, you can't add inst vars to them. This method should not be implemented and it should'n be called as well."
	self shouldNotImplement! !

!CBlock methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:28'!
doWhileTrue: aBlock
<c: 'do\{{0}\}while({1})'>! !

!CBlock methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
repeat
<c: 'while(true)\{{0}\}'>! !

!CBlock methodsFor: 'c-controlling' stamp: 'Richo 6/21/2011 19:03'!
whileTrue
<c: 'while({0})'>! !

!CBlock methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
whileTrue: aBlock
<c: 'while({0})\{{1}\}'>! !

CPrimitiveType subclass: #CBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CBoolean class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^'bool'! !

!CBoolean methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
and: aBlock
<c: '({0} && {1})'>! !

!CBoolean methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
ifFalse: falseBlock
<c: 'if(!!({0}))\{{1}\}'>! !

!CBoolean methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
ifFalse: falseBlock ifTrue: trueBlock
<c: 'if({0})\{{2}\}else\{{1}\}'>! !

!CBoolean methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
ifTrue: aBlock
<c: 'if({0})\{{1}\}'>! !

!CBoolean methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
ifTrue: trueBlock ifFalse: falseBlock
<c: 'if({0})\{{1}\}else\{{2}\}'>! !

!CBoolean methodsFor: 'c-logical operations' stamp: 'Richo 6/20/2011 17:29'!
not
<c: '!!({0})'>! !

!CBoolean methodsFor: 'c-controlling' stamp: 'Richo 6/20/2011 17:29'!
or: aBlock
<c: '({0} || {1})'>! !

CPrimitiveType subclass: #CNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

CNumber subclass: #CByte
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CByte class methodsFor: 'as yet unclassified' stamp: 'Richo 10/24/2011 12:43'!
asCString
	^'byte'! !

CNumber subclass: #CFloat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CFloat class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^'float'! !

CNumber subclass: #CLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CLong class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^'long'! !

!CNumber methodsFor: 'c-arithmetic' stamp: 'Richo 6/20/2011 17:29'!
* aNumber
<c: '({0} * {1})'>! !

!CNumber methodsFor: 'c-arithmetic' stamp: 'Richo 6/20/2011 17:29'!
+ aNumber
<c: '({0} + {1})'>! !

!CNumber methodsFor: 'c-arithmetic' stamp: 'Richo 6/20/2011 17:29'!
- aNumber
<c: '({0} - {1})'>! !

!CNumber methodsFor: 'c-arithmetic' stamp: 'Richo 6/20/2011 17:29'!
/ aNumber
<c: '({0} / {1})'>! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/22/2011 16:23'!
// aNumber
<returnType: #(CLong)> <argTypes: #(CLong)>
^ (self / aNumber) floor! !

!CNumber methodsFor: 'c-comparing' stamp: 'Richo 6/22/2011 16:23'!
< aNumber
<returnType: #(CBoolean)>
<c: '({0} < {1})'>! !

!CNumber methodsFor: 'c-comparing' stamp: 'Richo 6/22/2011 16:23'!
<= aNumber
<returnType: #(CBoolean)>
<c: '({0} <= {1})'>! !

!CNumber methodsFor: 'c-comparing' stamp: 'Richo 6/22/2011 16:23'!
> aNumber
<returnType: #(CBoolean)>
<c: '({0} > {1})'>! !

!CNumber methodsFor: 'c-comparing' stamp: 'Richo 6/22/2011 16:23'!
>= aNumber
<returnType: #(CBoolean)>
<c: '({0} >= {1})'>! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/22/2011 16:23'!
\\ aNumber
<returnType: #(CLong)> <argTypes: #(CLong)>
^ self - (self / aNumber * aNumber)! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/20/2011 17:30'!
abs
<c: 'abs({0})'>! !

!CNumber methodsFor: 'c-truncation and round off' stamp: 'Richo 6/20/2011 17:37'!
atRandom
<c: '(Random({0}) + 1)'>! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/22/2011 16:23'!
floor
<returnType: #(CLong)> <argTypes: #(CLong)>
^ self! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/22/2011 16:23'!
isDivisibleBy: aNumber
<returnType: #(CBoolean)> <argTypes: #(CLong)>
aNumber = 0 ifTrue: [^false].
self \\ aNumber = 0
	ifTrue: [^ true]
	ifFalse: [^ false]! !

!CNumber methodsFor: 'c-arithmetic' stamp: 'Richo 6/20/2011 17:30'!
negated
<c: '({0} * -1)'>! !

!CNumber methodsFor: 'c-truncation and round off' stamp: 'Richo 6/20/2011 17:37'!
random
<c: '(Random({0}) + 1)'>! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/22/2011 16:23'!
rounded
<returnType: #(CLong)>
self >= 0 
	ifTrue: [^ (self + 0.5) truncated]
	ifFalse: [^ (self - 0.5) truncated]! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/20/2011 17:36'!
sign
<c: 'sign({0})'>! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/22/2011 16:23'!
sin
	<returnType: #(CFloat)>
	<tempTypes: #(CFloat CFloat CFloat CFloat)>
	| sum delta self2 i |
	sum := self.
	delta := self.
	self2 := 0 - (self * self).
	i := 2.
	[delta > 0.000000000001]	 whileTrue: [
		"once"
		delta := (delta * self2) / (i * (i + 1)).
		i := i + 2.
		sum := sum + delta.
		"twice"
		delta := (delta * self2) / (i * (i + 1)).
		i := i + 2.
		sum := sum + delta].
	^ sum! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 6/20/2011 17:36'!
sqrt
<c: 'sqrt({0})'>! !

!CNumber methodsFor: 'c-enumerating' stamp: 'Richo 10/21/2011 18:53'!
timesRepeat: aBlock
<c: 'for(int i=0; i<{0};i++)\{{1}\}'>
"<c: 'repeat({0})\{{1}\}'>"
self flag: #Richo. "repeat() is not a valid C function"! !

!CNumber methodsFor: 'c-math functions' stamp: 'Richo 10/14/2011 14:46'!
truncated
<returnType: #(CLong)>
^ self! !

CNumber subclass: #CUnsignedLong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CUnsignedLong class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^ 'unsigned long'! !

!CPrimitiveType class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	self subclassResponsibility ! !

!CPrimitiveType class methodsFor: 'definition' stamp: 'Richo 2/22/2012 09:34'!
definition
	"Answer a String that defines the receiver."
	"Only shows #subclass:category:"
	^ String streamContents: [:stream |
		stream
			nextPutAll: superclass name;
			nextPutAll: self kindOfSubclass;
			store: self name;
			cr; tab; nextPutAll: 'category: '; store: (SystemOrganization categoryOfElement: self name) asString]! !

!CPrimitiveType class methodsFor: 'definition' stamp: 'Richo 6/20/2011 17:27'!
definitionST80
	"Only useful for the Etoys image"
	^ self definition! !

!CPrimitiveType class methodsFor: 'testing' stamp: 'Richo 6/30/2011 11:59'!
isPrimitive
	^ true! !

!CPrimitiveType class methodsFor: 'definition' stamp: 'Richo 6/20/2011 17:27'!
subclass: aSymbol instanceVariableNames: instVars classVariableNames: classVars poolDictionaries: poolDicts category: aString
	"Ignore instance variables, even if the user tries to force the superclass to add them"
	^ super subclass: aSymbol instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: aString! !

CPrimitiveType subclass: #CString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CString class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^'string'! !

!CString methodsFor: 'nxc-concatenation' stamp: 'Richo 6/20/2011 17:37'!
, aNXString
<c: 'StrCat({0}, {1})'>! !

CPrimitiveType subclass: #CVoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Hierarchy'!

!CVoid class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 18:02'!
asCString
	^ 'void'! !

CObject subclass: #CProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

CProgram subclass: #CHelloWorld
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CHelloWorld class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CHelloWorld class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CHelloWorld methodsFor: 'as yet unclassified' stamp: 'Richo 6/28/2011 10:47'!
main
	self printf: 'Hello world\n';
		system: ('PAUSE')! !

!CProgram class methodsFor: 'definition' stamp: 'Richo 1/10/2012 13:50'!
allIncludes
	^ self includesUpTo: CProgram! !

!CProgram class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:25'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #('/* C */ <stdio.h>' '/* C++ */ <cstdlib>' '/* C++ */ <iostream>')! !

!CProgram class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:25'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram class methodsFor: 'definition' stamp: 'Richo 3/30/2012 19:36'!
sourceCode
	^ self selectors asSortedCollection
		inject: self definition
		into: [:sub :next |
			sub , String cr, String cr,
			(self sourceCodeAt: next)]! !

!CProgram class methodsFor: 'translating' stamp: 'Richo 10/11/2011 10:41'!
translatedToC
	"Useful method to easily translate a program to c. By default the class name is used as program name"
	^ self translatedToC: #main! !

!CProgram class methodsFor: 'translating' stamp: 'Richo 10/11/2011 10:41'!
translatedToC: mainSelector
	"Useful method to easily translate a program to c. By default the class name is used as program name"
	^ self translatedToC: mainSelector named: self name! !

!CProgram class methodsFor: 'translating' stamp: 'Richo 10/11/2011 10:40'!
translatedToC: mainSelector named: programName 
	"Useful method to easily translate a program to c"
	^ CProgramTranslator translate: mainSelector of: self asProgramNamed: programName! !

!CProgram class methodsFor: 'translating' stamp: 'Richo 10/11/2011 10:42'!
translatedToCpp
	"Useful method to easily translate a program to c++. By default the class name is used as program name"
	^ self translatedToCpp: #main! !

!CProgram class methodsFor: 'translating' stamp: 'Richo 10/11/2011 10:42'!
translatedToCpp: mainSelector
	"Useful method to easily translate a program to c++. By default the class name is used as program name"
	^ self translatedToCpp: mainSelector named: self name! !

!CProgram class methodsFor: 'translating' stamp: 'Richo 10/11/2011 10:42'!
translatedToCpp: mainSelector named: programName 
	"Useful method to easily translate a program to c++"
	^ CppProgramTranslator translate: mainSelector of: self asProgramNamed: programName! !

!CProgram methodsFor: 'c' stamp: 'Richo 10/24/2011 14:20'!
c: aString
	"Inline the argument directly in the c code"
	<c>! !

!CProgram methodsFor: 'as yet unclassified' stamp: 'Richo 6/28/2011 10:47'!
printf: aString
	<c: 'printf({1})' >! !

!CProgram methodsFor: 'as yet unclassified' stamp: 'Richo 6/23/2011 16:51'!
printf: aString value: obj
	<c: 'printf({1},{2})' >! !

!CProgram methodsFor: 'as yet unclassified' stamp: 'Richo 6/23/2011 17:54'!
system: str
	<c: 'system({1})'>! !

CProgram subclass: #CProgram1
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram1 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram1 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong)! !

!CProgram1 methodsFor: 'as yet unclassified' stamp: 'Richo 7/27/2011 15:32'!
main
	| var3 |
	<tempTypes: #(CLong)>
	<returnType: #(CLong)>
	var1 := 3.
	var2 := 4.
	var3 := 17.
	self printf: '%d\n' value: var1 + var2 - var3;
		system: 'PAUSE'.
	^ 42! !

CProgram subclass: #CProgram10
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram10 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:26'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram10 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:26'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram10 methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 16:20'!
main
	| list |
	<tempTypes: #(CLinkedList)>
	list := CLinkedList new.
	list isNil
		ifFalse: [self printf: 'list no es nil \n'].
	list value isNil
		ifTrue: [self printf: 'value si es nil\n'].
	list value: 1.
	list value isNil
		ifFalse: [self printf: 'value: %d\n' value: list value].
	list add: 2.
	(list at: 2) isNil
		ifFalse: [self printf: 'value: %d\n' value: (list at: 2) value].
	list add: 3.
	list add: 4.
	self printf: 'value: %d\n' value: (list at: 3) value.
	self printf: 'value: %d\n' value: (list at: 4) value.
	self pause.! !

!CProgram10 methodsFor: 'as yet unclassified' stamp: 'Richo 10/12/2011 16:36'!
pause
	self system: 'PAUSE'! !

CProgram subclass: #CProgram11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram11 class methodsFor: 'definition' stamp: 'Richo 2/22/2012 09:46'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram11 class methodsFor: 'definition' stamp: 'Richo 2/22/2012 09:46'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram11 methodsFor: 'as yet unclassified' stamp: 'Richo 1/13/2012 19:04'!
main
	self printf: '%d\n' value: (5.5 // 2.0);
		printf: '%d\n' value: (5 // 2).
	self pause! !

!CProgram11 methodsFor: 'as yet unclassified' stamp: 'Richo 1/3/2012 15:54'!
pause
	self system: 'PAUSE'! !

CProgram subclass: #CProgram12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram12 class methodsFor: 'definition' stamp: 'Richo 3/1/2012 18:46'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram12 class methodsFor: 'definition' stamp: 'Richo 3/1/2012 18:46'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram12 methodsFor: 'as yet unclassified' stamp: 'Richo 3/1/2012 18:53'!
main
	(5 isDivisibleBy: 2)
		ifTrue: [self printf: 'Yes']
		ifFalse: [self printf: 'No'].
	self system: 'PAUSE'! !

CProgram subclass: #CProgram2
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram2 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram2 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong #CLong)! !

!CProgram2 methodsFor: 'as yet unclassified' stamp: 'Richo 7/27/2011 15:34'!
main
	var2 := 3.
	var1 := 4.
	self printf: '%d\n' value: (self sumar: var2 y: var1);
		system: 'PAUSE'! !

!CProgram2 methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 16:23'!
sumar: a y: b
	<argTypes: #(CLong CLong)>
	<returnType: #(CLong)>
	^ a + b! !

CProgram subclass: #CProgram3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram3 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram3 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram3 methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 16:43'!
main
	| var |
	<tempTypes: #(CLong)>
	var := 5.
	var > 10
		ifTrue: [self printf: 'Mayor']
		ifFalse: [self printf: 'Menor'].
	self printf: '\n'.
	self system: 'PAUSE'! !

CProgram subclass: #CProgram4
	instanceVariableNames: 'var'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram4 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram4 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLong)! !

!CProgram4 methodsFor: 'as yet unclassified' stamp: 'Richo 7/27/2011 17:24'!
main
	| p |
	<tempTypes: #(CProgram4)>
	p := CProgram4 new.
	p var: 5.
	var := 6.
	self print: p; 
		print: self;
		var: 7;
		print: self;
		system: 'PAUSE'! !

!CProgram4 methodsFor: 'as yet unclassified' stamp: 'Richo 7/27/2011 16:36'!
print: p
	<argTypes: #(CProgram4)>
	self printf: '%d\n' value: p var! !

!CProgram4 methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2011 17:28'!
var
	<returnType: #(CLong)>
	^ var! !

!CProgram4 methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2011 17:29'!
var: aNumber
	<argTypes: #(CLong)>
	var := aNumber! !

CProgram subclass: #CProgram5
	instanceVariableNames: 'p'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram5 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram5 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CProgram4)! !

!CProgram5 methodsFor: 'as yet unclassified' stamp: 'Richo 6/30/2011 13:10'!
hello
	self printf: 'Hello World\n'
	! !

!CProgram5 methodsFor: 'as yet unclassified' stamp: 'Richo 1/3/2012 17:06'!
main
	| q |
	<tempTypes: #(CProgram4)>
	self hello.
	p := CProgram4 new.
	p var: 5.
	q := p.
	self printf: '%d\n' value: p var.
	self printf: '%d\n' value: q var.
	p var: 6.
	self printf: '%d\n' value: p var.
	self printf: '%d\n' value: q var.
	self system: 'PAUSE'! !

CProgram subclass: #CProgram6
	instanceVariableNames: 'p var'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram6 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram6 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CProgram6 #CLong)! !

!CProgram6 methodsFor: 'as yet unclassified' stamp: 'Richo 7/1/2011 14:04'!
hello
	self printf: 'Hello World: %d\n' value: self var! !

!CProgram6 methodsFor: 'as yet unclassified' stamp: 'Richo 7/1/2011 14:04'!
main
	p := CProgram6 new.
	p var: 3.
	p hello.
	var := 4.
	self hello.
	self system: 'PAUSE'! !

!CProgram6 methodsFor: 'as yet unclassified' stamp: 'Richo 7/1/2011 14:04'!
var
	<returnType: #(CLong)>
	^ var! !

!CProgram6 methodsFor: 'as yet unclassified' stamp: 'Richo 7/1/2011 14:04'!
var: aNumber
	<argTypes: #(CLong)>
	var := aNumber! !

CProgram subclass: #CProgram7
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram7 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram7 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #(#CLinkedList)! !

!CProgram7 methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2011 16:28'!
main
	list := CLinkedList new.
	list value: 1;
		add: 2.
	self print: (list at: 1);
		print: (list at: 2);
		pause ! !

!CProgram7 methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2011 17:00'!
pause
	<inlined>
	self system: 'PAUSE'! !

!CProgram7 methodsFor: 'as yet unclassified' stamp: 'Richo 7/14/2011 17:30'!
print: n
	<inlined>
	<argTypes: #(CLong)>
	self printf: '%d\n' value: n.
! !

CProgram subclass: #CProgram8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram8 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram8 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram8 methodsFor: 'as yet unclassified' stamp: 'Richo 10/13/2011 14:13'!
main
	| list |
	<tempTypes: #(CLinkedList)>
	list := CLinkedList with: 1.
	list add: 2.
	self printf: '%d\n' value: list value.
	self printf: '%d\n' value: (list at: 2) value.
	self pause.! !

!CProgram8 methodsFor: 'as yet unclassified' stamp: 'Richo 7/15/2011 13:54'!
pause
	<inlined>
	self system: 'PAUSE'! !

CProgram subclass: #CProgram9
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgram9 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram9 class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:29'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgram9 methodsFor: 'as yet unclassified' stamp: 'Richo 1/13/2012 19:26'!
main
	| list |
	<tempTypes: #(CLinkedList)>
	list := CLinkedList with: 1.
	list add: 2;
		add: 3;
		add: 4.
	self printf: '%d\n' value: (list at: 1) value.
	self printf: '%d\n' value: (list at: 2) value.
	self printf: '%d\n' value: (list at: 3).
	self printf: '%d\n' value: (list at: 4).
	self pause.! !

!CProgram9 methodsFor: 'as yet unclassified' stamp: 'Richo 10/11/2011 17:45'!
pause
	<inlined>
	self system: 'PAUSE'! !

CProgram subclass: #CProgramInline2Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgramInline2Test class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgramInline2Test class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgramInline2Test methodsFor: 'as yet unclassified' stamp: 'Richo 7/22/2011 19:36'!
main
	self prueba: 'Richo'.
	^ self prueba * 4! !

!CProgramInline2Test methodsFor: 'as yet unclassified' stamp: 'Richo 7/22/2011 19:36'!
prueba
	| var |
	<inlined>
	<tempTypes: #(CLong)>
	<returnType: #(CLong)>
	var := 42.
	^ 57! !

!CProgramInline2Test methodsFor: 'as yet unclassified' stamp: 'Richo 7/22/2011 19:37'!
prueba: arg
	<inlined>
	<argTypes: #(CString)>
	<returnType: #(CString)>
	^ arg! !

CProgram subclass: #CProgramInlineTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Programs'!

!CProgramInlineTest class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
includes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgramInlineTest class methodsFor: 'definition' stamp: 'Richo 1/13/2012 19:30'!
instanceVariableTypes
"This method was autogenerated. Do not change unless you *really* know what you're doing"
^ #()! !

!CProgramInlineTest methodsFor: 'as yet unclassified' stamp: 'Richo 7/22/2011 13:27'!
main
	| var1 var2 |
	<tempTypes: #(CLong CUnsignedLong)>
	var2 := 1.
	var1 := var2 * 3.
	self pause.
	self prueba: var1 * var2.
	var1 := 5.
	self prueba: var2 * var1.
	^ 5! !

!CProgramInlineTest methodsFor: 'as yet unclassified' stamp: 'Richo 7/21/2011 13:06'!
pause
	<inlined>
	self system: 'PAUSE'! !

!CProgramInlineTest methodsFor: 'as yet unclassified' stamp: 'Richo 7/22/2011 13:30'!
prueba2
	<inlined>
	<returnType: #(CLong)>
	^ 5! !

!CProgramInlineTest methodsFor: 'as yet unclassified' stamp: 'Richo 7/22/2011 13:30'!
prueba: arg
	<inlined>
	<argTypes: #(CLong)>
	^ self prueba2 * 2! !

Object subclass: #CPrimitiveRule
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Utilities'!

!CPrimitiveRule commentStamp: 'Richo 6/28/2011 10:53' prior: 0!
A CPrimitiveRule is is a very simple way of defining a rule to translate a smalltalk message to a c primitive. Every function (such as "printf" or "system"), every operator (such as "+" or "=="), and every control structure (such as "if", "while", or "repeat") is considered to be a c primitive. To define a method as a c primitive you should use the #c: pragma (look at the senders of #c: for examples).

To create a rule simply send '#as: CPrimitiveRule' to a well formed string. For example:

	'NumOut({2}, {3}, {1})' as: CPrimitiveRule.
	'({0} + {1})' as: CPrimitiveRule.
	'if({0})\{{1}\}else\{{2}\}' as: CPrimitiveRule.
	
Once a rule is created it can be applied to a message node using a translator by sending #applyTo:using:. This mehod will then replace all '{n}' in the string with the translated arguments ({0} represents the receiver).

Instance Variables
	value:		<String>

value
	- The string that defines how to apply the rule.
!

!CPrimitiveRule class methodsFor: 'instance creation' stamp: 'Richo 6/20/2011 20:59'!
newFrom: aString
	^ self on: aString! !

!CPrimitiveRule class methodsFor: 'instance creation' stamp: 'Richo 6/28/2011 12:06'!
on: aByteString 
	^ self basicNew initializeWith: aByteString! !

!CPrimitiveRule methodsFor: 'applying' stamp: 'Richo 6/20/2011 21:13'!
applyTo: aMessageNode using: aCMethodTranslator 
	"Visits the message node receiver and arguments and replaces the '{n}' in the string with the result ({0} represents the receiver). It reinitializes the source stream for every node so that we only get the result of visiting that node"
	^ self format: ({aMessageNode receiver}, aMessageNode arguments
		collectWithIndex: [:node :index | 
		(String streamContents: [:stream | 
				aCMethodTranslator withSource: stream do: [aCMethodTranslator visitNode: node].
				self removeSemicolonIfNecessaryOn: stream for: index - 1])])! !

!CPrimitiveRule methodsFor: 'applying' stamp: 'Richo 2/22/2012 09:59'!
format: aCollection
	"Zero based. It goes through value increasing by 1 the enclosed expressions and then it sends regular #format:"
	| oldStream newStream last next |
	oldStream := value readStream.
	newStream := WriteStream on: ''.
	[oldStream atEnd]
		whileFalse: [
		last := next.
		next := oldStream next.
		newStream nextPut: next.
		(next = ${ and: [last ~= $\])
			ifTrue: [| n | "We found an enclosed expression"
			n := oldStream upTo: $}.
			newStream nextPutAll: (n asNumber + 1) asString, '}'.
			]
	].
	^ newStream contents format: aCollection
	! !

!CPrimitiveRule methodsFor: 'initializing' stamp: 'Richo 6/28/2011 12:07'!
initializeWith: aByteString 
	self initialize.
	value := aByteString ! !

!CPrimitiveRule methodsFor: 'printing' stamp: 'Richo 6/20/2011 20:59'!
printOn: aStream
super printOn: aStream.
aStream nextPut: $(.
aStream nextPutAll: value.
aStream nextPut: $)! !

!CPrimitiveRule methodsFor: 'applying' stamp: 'Richo 6/20/2011 20:59'!
removeSemicolonIfNecessaryOn: source for: argIndex
	"Depending on the position of the argument in the rule string, it can be necessary to remove the semicolon after the statement. For now, we only leave the semicolon if the token is surrounded by curly brackets {}.
	For instance, in the rule below
	
	'while({0})\{{1}\}'
	
	The node replacing the {0} token will have its semicolon removed, whereas the {1} won't. Of course, most of the time it won't be necessary to remove any semicolon (if {0} is a literal or a variable, for instance)."
	| index newContents oldContents rule token |
	oldContents := source contents.
	rule := value withBlanksCondensed.
	
	"Do nothing if the source does not end with a semicolon"
	(oldContents size > 2 and: [oldContents endsWith: ';', String cr]) ifFalse: [^self].

	token := '{', argIndex asString ,'}'.
	index := rule findString: token.

	"Do nothing if the token is not in the rule"
	index = 0 ifTrue: [^self].

	"Do nothing if the token is not surrounded by curly brackets"
	((rule at: index - 2 ifAbsent: ['']) asString ,
	(rule at: index - 1 ifAbsent: ['']) asString ,
	(rule at: index + token size ifAbsent: ['']) asString ,
	(rule at: index + token size + 1 ifAbsent: ['']) asString) = '\{\}'
		ifTrue: [^self].

	"Okay, you can now safely remove the semicolon"
	newContents := oldContents allButLast: 2.
	source reset; nextPutAll: newContents.! !

Object subclass: #CProgramTranslator
	instanceVariableNames: 'program markedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Translators-C'!

!CProgramTranslator commentStamp: 'Richo 10/14/2011 14:30' prior: 0!
A CProgramTranslator is responsible for translating subclasses of CProgram from smalltalk to C. It's public protocol is very simple, just use #translate:of:asProgramNamed:, which returns an instance of CTranslatedProgram.
An even easier way of translating programs is sending #translatedToC to a CProgram subclass. For example:

	CHelloWorld translatedToC: #main.
	
You can also specify a different program name:

	CHelloWorld translatedToC: #main named: 'Other program name'.

The translation is done recursively, starting from the #main method and translating every method call found from there. For more information, see CMethodTranslator comment.


Instance Variables
	program:		<CTranslatedProgram>

program
	- The program being translated.
!

!CProgramTranslator class methodsFor: 'kit' stamp: 'Richo 9/28/2011 16:48'!
kit
	^ CKit! !

!CProgramTranslator class methodsFor: 'instance creation' stamp: 'Richo 6/20/2011 20:59'!
new
	self shouldNotImplement! !

!CProgramTranslator class methodsFor: 'instance creation' stamp: 'Richo 10/11/2011 10:44'!
translate: mainSelector of: aCProgram asProgramNamed: programName
	^ (self basicNew initializeWithProgram: (self kit newProgramNamed: programName))
			translateMain: mainSelector of: aCProgram! !

!CProgramTranslator methodsFor: 'initializing' stamp: 'Richo 6/28/2011 11:34'!
initializeWithProgram: aCTranslatedProgram 
	program := aCTranslatedProgram.
	self initialize! !

!CProgramTranslator methodsFor: 'testing' stamp: 'Richo 10/20/2011 16:25'!
isMarked: selector of: class
	^ markedMethods includes: class -> selector.! !

!CProgramTranslator methodsFor: 'kit' stamp: 'Richo 9/28/2011 16:49'!
kit
	^ self class kit! !

!CProgramTranslator methodsFor: 'testing' stamp: 'Richo 10/20/2011 16:25'!
mark: selector of: class
	markedMethods add: class -> selector.! !

!CProgramTranslator methodsFor: 'accessing' stamp: 'Richo 6/21/2011 15:33'!
methodTranslator
	"Override if you want to define a specific method translator"
	^ CMethodTranslator! !

!CProgramTranslator methodsFor: 'translating' stamp: 'Richo 1/3/2012 17:16'!
translateMain: mainSelector of: aCProgram
	markedMethods := Set new.
	[(self translateMethod: mainSelector of: aCProgram)
		isMain: true]
		on: CInstVarToImplement do: [:notification |
			(program addStruct: notification struct)
				addVar: notification variable.
			notification resume].
	^ program! !

!CProgramTranslator methodsFor: 'translating' stamp: 'Richo 1/3/2012 17:19'!
translateMethod: selector of: class
	"Recursively translates this method and all methods called from it. Before translating we mark the method so that if the method gets recursive we won't enter an infinite loop.
	Returns the method translated"
	[| method |
	self mark: selector of: class.
	(program
		addStruct: (self kit newStructFor: class))
			addMethod: (method := self methodTranslator 
										translate: selector 
										of: class 
										with: self kit).
	^ method]
		on: CMethodToImplement
		do: [:noti |
			(self isMarked: noti methodSelector of: noti methodClass)
				ifFalse: [self translateMethod: noti methodSelector of: noti methodClass].
			noti resume]! !

CProgramTranslator subclass: #CppProgramTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Translators-Cpp'!

!CppProgramTranslator class methodsFor: 'kit' stamp: 'Richo 9/28/2011 16:50'!
kit
	^ CppKit ! !

!CppProgramTranslator methodsFor: 'as yet unclassified' stamp: 'Richo 6/22/2011 11:09'!
methodTranslator
	"Override if you want to define a specific method translator"
	^ CppMethodTranslator! !

Object subclass: #CTranslatedFunction
	instanceVariableNames: 'ownerClass body arguments temporaries returnType selfType selector isMain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

!CTranslatedFunction class methodsFor: 'instance creation' stamp: 'Richo 10/11/2011 10:37'!
class: ownerClass selector: aSymbol body: bodySource arguments: argVars temporaries: tempVars returnType: aCType selfType: anotherCType
	^ self basicNew initializeWithClass: ownerClass selector: aSymbol body: bodySource arguments: argVars temporaries: tempVars returnType: aCType selfType: anotherCType! !

!CTranslatedFunction methodsFor: 'comparing' stamp: 'Richo 6/29/2011 11:29'!
= anObject
	(anObject isKindOf: self class) ifFalse: [^ false].
	^ self source = anObject source! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 7/8/2011 20:18'!
arguments
	^ arguments ! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 1/3/2012 18:26'!
body
	^ body! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 10/11/2011 10:35'!
declaration
	^ String
		streamContents: [:stream | 
			stream nextPutAll: self returnType source.
			stream nextPutAll: ' ' , self name , '('.
			self arguments
				do: [:each | stream nextPutAll: each source]
				separatedBy: [stream nextPutAll: ', '].
			stream nextPutAll: ');']! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 3/2/2012 15:42'!
formattedSource
	^ CFormatter format: self source! !

!CTranslatedFunction methodsFor: 'comparing' stamp: 'Richo 6/20/2011 20:49'!
hash
	^ self source hash hashMultiply ! !

!CTranslatedFunction methodsFor: 'initializing' stamp: 'Richo 10/11/2011 10:51'!
initializeWithClass: aClass selector: aSymbol body: aByteString arguments: argVars temporaries: tempVars returnType: aCType selfType: anotherCType
	isMain := false.
	ownerClass := aClass.
	selector := aSymbol.
	body := aByteString.
	arguments := argVars.
	temporaries := tempVars.
	returnType := aCType.
	selfType := anotherCType.
	self initialize.! !

!CTranslatedFunction methodsFor: 'testing' stamp: 'Richo 10/11/2011 10:50'!
isMain
	^ isMain! !

!CTranslatedFunction methodsFor: 'testing' stamp: 'Richo 10/11/2011 10:50'!
isMain: aBoolean
	isMain := aBoolean! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 10/13/2011 17:39'!
name
	^ self selfType name, selector asCIdentifier! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 10/7/2011 19:44'!
ownerClass
	^ ownerClass! !

!CTranslatedFunction methodsFor: 'printing' stamp: 'Richo 3/2/2012 15:43'!
printOn: aStream
	aStream nextPutAll: self formattedSource! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 10/7/2011 19:29'!
returnType
	^ returnType! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 10/11/2011 10:56'!
selector
	^ selector! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 10/11/2011 10:33'!
selfType
	^ selfType! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 3/2/2012 15:43'!
source
	^ String streamContents: [:stream |
		stream nextPutAll: self declaration allButLast; cr.
		stream nextPut: ${; cr.
		self temporaries do: [:each | stream nextPutAll: each source, ';'; cr].
		stream nextPutAll: self body.
		stream nextPut: $}]! !

!CTranslatedFunction methodsFor: 'accessing' stamp: 'Richo 7/8/2011 20:18'!
temporaries 
	^ temporaries ! !

CTranslatedFunction subclass: #CppTranslatedMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-Cpp'!

CppTranslatedMethod subclass: #CppTranslatedMetaMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-Cpp'!

!CppTranslatedMetaMethod methodsFor: 'as yet unclassified' stamp: 'Richo 1/13/2012 20:04'!
declaration
	"Meta methods are declared 'static'"
	^ 'static ', super declaration! !

!CppTranslatedMethod methodsFor: 'accessing' stamp: 'Richo 10/13/2011 17:40'!
name
	^ selector asCIdentifier! !

CppTranslatedMethod subclass: #CppTranslatedPrimMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-Cpp'!

!CppTranslatedPrimMethod methodsFor: 'as yet unclassified' stamp: 'Richo 1/13/2012 20:06'!
body
	self flag: #Richo. "This is a hack. We should generate the body with 'self' instead of 'this' from the start"	
	^ super body copyReplaceTokens: 'this' with: 'self'! !

!CppTranslatedPrimMethod methodsFor: 'as yet unclassified' stamp: 'Richo 1/13/2012 20:00'!
declaration
	^ String streamContents: [:stream |
		stream nextPutAll: 'static '.
		stream nextPutAll: self returnType source, ' '.
		stream nextPutAll: self name, '('.
		stream nextPutAll: self selfType source;
				nextPutAll: ' self'.
		self arguments notEmpty ifTrue: [stream nextPutAll: ', '].
		self arguments
			do: [:each | stream nextPutAll: each source]
			separatedBy: [stream nextPutAll: ', '].
		stream nextPutAll: ');']! !

Object subclass: #CTranslatedProgram
	instanceVariableNames: 'programName structs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

!CTranslatedProgram class methodsFor: 'instance creation' stamp: 'Richo 6/20/2011 20:49'!
named: programName
	^ (self basicNew setName: programName) initialize! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:49'!
addStruct: aCStruct
	"Adds a struct for the given class only if a struct is not already added. Returns the struct"
	^ structs
		detect: [:each | each ownerClass = aCStruct ownerClass]
		ifNone: [structs addFirst: aCStruct]! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 2/22/2012 09:45'!
allIncludes
^ (structs collect: [:each | each allIncludes])
		inject: Set new
		into: [:subTotal :next | subTotal , next]! !

!CTranslatedProgram methodsFor: 'printing' stamp: 'Richo 3/27/2012 11:14'!
asStringWithLineNumbers
	| nDigits print |
	nDigits := self asString lineCount asString size.
	print := [:n || result |
		result := n printString.
		(nDigits - result size) timesRepeat: [result := '0', result].
		result].
	^ String streamContents: [:stream || count |
		count := 1.
		self asString linesDo: [:line |
			stream 
				nextPutAll: (print value: count), '.';
				tab; nextPut: $|; tab;
				nextPutAll: line; cr.
			count := count + 1]]! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 3/2/2012 16:28'!
header
	"Store program's name"
	| source |
	source := WriteStream on: ''.
	source nextPutAll: '/* ', self headerFileName ,' */'; cr; cr.

	"Store includes"
	self allIncludes
		do: [:include |
			source nextPutAll: '#include ';
				nextPutAll: include;
				cr]
		separatedBy: [source cr].
	source cr.

	"Store structs definitions"
	structs do: [:struct |
		source nextPutAll: struct source; cr.
	] separatedBy: [source cr].
	source cr.

	"Store methods' declarations"
	source nextPutAll: self mainDeclaration; cr.
	self methods do: [:method |
			source nextPutAll: method declaration; cr.
		].
	source cr.

	^ CFormatter format: source contents! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 6/28/2011 10:51'!
headerFileName
	^ programName, '.h'! !

!CTranslatedProgram methodsFor: 'initialize-release' stamp: 'Richo 1/3/2012 17:00'!
initialize
	super initialize.
	structs := OrderedCollection new! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 2/22/2012 09:25'!
mainDeclaration
	^ (self mainImplementation copyUpTo: Character cr) , ';'! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 10/13/2011 13:34'!
mainImplementation
	self flag: #Richo. "Don't forget to initialize class structs here!!"
	^'int main(void)
\{
{1}* program = ({1}*)malloc(sizeof({1}));
//Initialize class structs here
{2}(program);
return 0;
\}' format: {
	self mainMethod ownerClass asCString.
	self mainMethod name}! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 10/11/2011 17:19'!
mainMethod
	^ self methods detect: [:each | each isMain]! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 10/11/2011 17:21'!
methods
	^ structs inject: #() into: [:subTotal :next | subTotal , next methods]! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 6/20/2011 20:49'!
name
	^ programName ! !

!CTranslatedProgram methodsFor: 'printing' stamp: 'Richo 10/11/2011 17:00'!
printOn: aStream
	aStream
		nextPutAll: self header; cr;
		nextPutAll: '=================='; cr;
		nextPutAll: self source! !

!CTranslatedProgram methodsFor: 'fileOut' stamp: 'Richo 6/21/2011 17:36'!
saveInDirectory: aDirectory
	aDirectory
		forceNewFileNamed: self headerFileName do: [:file | file nextPutAll: self header];
		forceNewFileNamed: self sourceFileName do: [:file | file nextPutAll: self source]! !

!CTranslatedProgram methodsFor: 'private' stamp: 'Richo 10/11/2011 17:03'!
setName: aString
	programName := aString asIdentifier: true
	
	! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 3/2/2012 16:28'!
source
	"Store program's name"
	| source |
	source := WriteStream on: ''.
	source nextPutAll: '/* ', self sourceFileName ,' */'; cr; cr.

	"Store header include"
	source nextPutAll: '#include "', self headerFileName, '"'; cr; cr.
	
	"Store methods implementation"
	source nextPutAll: self mainImplementation; cr; cr.
	self methods do: [:method |
			source nextPutAll: method source]
			separatedBy: [source cr; cr].

	^ CFormatter format: source contents! !

!CTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 6/28/2011 10:51'!
sourceFileName
	^ programName , '.c'! !

CTranslatedProgram subclass: #CppTranslatedProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-Cpp'!

!CppTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 3/2/2012 17:29'!
header
	"Store program's name"
	| source |
	source := WriteStream on: ''.
	source nextPutAll: '/* ', self headerFileName ,' */'; cr; cr.

	"Store includes"
	self allIncludes
		do: [:include |
			source nextPutAll: '#include ';
				nextPutAll: include;
				cr]
		separatedBy: [source cr].
	source cr.

	"Store structs definitions"
	structs do: [:struct |
		source nextPutAll: struct source; cr.
	].
	source cr.
	
	^ CFormatter format: source contents! !

!CppTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 10/7/2011 19:44'!
mainImplementation
	^'int main()
\{
{1}* program = new {1}();
program->{2}();
return 0;
\}' format: {
	self mainMethod ownerClass asCString.
	self mainMethod name}

! !

!CppTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 3/2/2012 16:28'!
source
	"Store program's name"
	| source |
	source := WriteStream on: ''.
	source nextPutAll: '/* ', self sourceFileName ,' */'; cr; cr.

	"Store header include"
	source nextPutAll: '#include "', self headerFileName, '"'; cr; cr.
	
	"Store main method implementation. The methods are included in the header inside their respective classes"
	source nextPutAll: self mainImplementation; cr; cr.

	^ CFormatter format: source contents! !

!CppTranslatedProgram methodsFor: 'accessing' stamp: 'Richo 6/28/2011 10:51'!
sourceFileName 
	^ programName, '.cpp'! !

Object subclass: #CTranslatedStruct
	instanceVariableNames: 'ownerClass variables methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

CTranslatedStruct subclass: #CTranslatedMetaStruct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

!CTranslatedMetaStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:44'!
allIncludes
	"Metaclasses don't have includes"
	^ #()! !

!CTranslatedMetaStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:53'!
className
	^ ownerClass instanceSide asCString! !

!CTranslatedMetaStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:53'!
source
	^ String streamContents: [:source || className |
		className := self className.
		"Class side"
		source nextPutAll: 'struct _', className , '_meta {'; cr.
		self flag: #Richo. "No class inst vars here?"
		source nextPutAll: '};'; cr.
		source nextPutAll: 'typedef struct _', className, '_meta ', className, '_meta;'; cr.
		source nextPutAll: className , '_meta* ', className, '_class;'; cr; cr.
		]! !

CTranslatedStruct subclass: #CTranslatedPrimStruct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

!CTranslatedPrimStruct methodsFor: 'as yet unclassified' stamp: 'Richo 1/13/2012 19:32'!
source
	"Primitive classes shouldn't generate any source code in C"
	^ ''! !

!CTranslatedStruct class methodsFor: 'instance creation' stamp: 'Richo 6/28/2011 12:07'!
for: aClass 
	^ self basicNew initializeWith: aClass! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:53'!
addMethod: aCTranslatedMethod 
	methods add: aCTranslatedMethod.! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 6/20/2011 20:50'!
addVar: aCInstVar 
	variables add: aCInstVar ! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:43'!
allIncludes
	^ ownerClass allIncludes! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:53'!
className
	^ ownerClass asCString! !

!CTranslatedStruct methodsFor: 'initialize-release' stamp: 'Richo 10/11/2011 17:13'!
initializeWith: aClass
	self initialize.
	ownerClass := aClass.
	variables := Set new.
	methods := Set new.! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 10/11/2011 17:21'!
methods
	^ methods asArray! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 6/20/2011 20:49'!
ownerClass
	^ ownerClass ! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 1/13/2012 18:53'!
source
	^ String streamContents: [:source || className |
		className := self className.
		"Instance side"
		source nextPutAll: 'struct _', className, ' {'; cr.
		variables do: [:var |
			self flag: #Richo. "I should have a type, not an ownerClass..."
			var type name = ownerClass asCString
				ifTrue: [source nextPutAll: 'struct _'].
			source nextPutAll: var source, ';'; cr].
		source nextPutAll: '};'; cr.
		source nextPutAll: 'typedef struct _', className, ' ', className, ';'		
		]! !

!CTranslatedStruct methodsFor: 'accessing' stamp: 'Richo 10/11/2011 17:21'!
variables
	^ variables asArray! !

CTranslatedStruct subclass: #CppTranslatedClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-Cpp'!

!CppTranslatedClass methodsFor: 'accessing' stamp: 'Richo 1/13/2012 19:13'!
className
	^ ownerClass asCString! !

!CppTranslatedClass methodsFor: 'accessing' stamp: 'Richo 1/13/2012 19:13'!
source
	^ String streamContents: [:source |
		source nextPutAll: 'class ';
				nextPutAll: self className;
				nextPutAll: ' {'; cr.
		source nextPutAll: 'private:'; cr; cr.
		variables do: [:var |
			source nextPutAll: var source; nextPut: $;; cr].
		source cr; nextPutAll: 'public:'; cr; cr.
		methods do: [:method |
			source nextPutAll: method source; cr]
			separatedBy: [source cr].
		source nextPutAll: '};']! !

CppTranslatedClass subclass: #CppTranslatedPrimClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-Cpp'!

!CppTranslatedPrimClass methodsFor: 'accessing' stamp: 'Richo 1/13/2012 19:13'!
className
	^ ownerClass name! !

Object subclass: #CTranslatedVariable
	instanceVariableNames: 'varName varType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

!CTranslatedVariable class methodsFor: 'instance creation' stamp: 'Richo 10/7/2011 18:52'!
name: varName type: varType
	^ self basicNew initializeWithName: varName type: varType! !

!CTranslatedVariable methodsFor: 'comparing' stamp: 'Richo 10/7/2011 18:52'!
= anObject
	(anObject isKindOf: self class) ifFalse: [^ false].
	^ self name = anObject name and: [self type = anObject type]! !

!CTranslatedVariable methodsFor: 'comparing' stamp: 'Richo 10/7/2011 18:52'!
hash
	^ (self name hash hashMultiply bitXor: self type hash) hashMultiply ! !

!CTranslatedVariable methodsFor: 'initialization' stamp: 'Richo 10/11/2011 17:08'!
initializeWithName: aString type: aCType
	self initialize.
	varName := aString.
	varType := aCType! !

!CTranslatedVariable methodsFor: 'accessing' stamp: 'Richo 4/9/2012 16:47'!
name
	^ varName! !

!CTranslatedVariable methodsFor: 'accessing' stamp: 'Richo 10/12/2011 15:19'!
source
	^ self type source, ' ', self name! !

!CTranslatedVariable methodsFor: 'accessing' stamp: 'Richo 10/7/2011 18:18'!
type
	^ varType! !

Object subclass: #CType
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTranslator-Output-C'!

!CType class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 17:54'!
newFrom: aClass
	^ self on: aClass! !

!CType class methodsFor: 'as yet unclassified' stamp: 'Richo 10/7/2011 17:52'!
on: aClass
	^ self basicNew initializeWith: aClass! !

!CType methodsFor: 'comparing' stamp: 'Richo 10/7/2011 18:24'!
= anObject
	(anObject isKindOf: self class) ifFalse: [^ false].
	^ anObject valueEquals: value! !

!CType methodsFor: 'comparing' stamp: 'Richo 10/7/2011 18:25'!
hash
	^ value hash hashMultiply! !

!CType methodsFor: 'initialize-release' stamp: 'Richo 10/7/2011 17:53'!
initializeWith: aClass
	self initialize.
	value := aClass! !

!CType methodsFor: 'accessing' stamp: 'Richo 10/11/2011 10:21'!
name
	^ value instanceSide asCString! !

!CType methodsFor: 'printing' stamp: 'Richo 10/7/2011 18:21'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	value printOn: aStream.
	aStream nextPut: $)! !

!CType methodsFor: 'accessing' stamp: 'Richo 1/3/2012 18:29'!
source
	self flag: #Richo. "Fix this!!"
	^ self name,
	(value isMeta 
		ifTrue: ['_meta*']
		ifFalse: [value isPrimitive 
					ifTrue: ['']
					ifFalse: ['*']])! !

!CType methodsFor: 'comparing' stamp: 'Richo 10/7/2011 18:24'!
valueEquals: aClass
	"Private. Used for equality comparison"
	^ value = aClass! !

!SequenceableCollection methodsFor: '*ctranslator' stamp: 'Richo 3/2/2012 17:35'!
beginsWithAnyOf: aCollection
	"Return true if the receiver starts with any of the elements in aCollection."
	^aCollection anySatisfy:[:prefix| self beginsWith: prefix].! !

!Number methodsFor: '*ctranslator' stamp: 'Richo 3/1/2012 19:38'!
printShowingAtMostDecimalPlaces: placesDesired
	| str count |
	str := self printShowingDecimalPlaces: placesDesired.
	"Now remove trailing zeros"
	count := 0.
	str reverseDo: [:chr |
		chr caseOf: {
			[$0] -> [count := count + 1].
			[$.] -> [^ str allButLast: count - 1]
		} otherwise: [^ str allButLast: count]].
	^ str! !
